{ --------------------------------------------------------------}
{ Ramcovy program metody razeni                                 }
{ --------------------------------------------------------------}
PROGRAM Main;

USES CRT, DOS;

CONST N = 100;                     { max. velikost vnitrniho seznamu}
      Nextrn=500;                  { max. velikost externiho seznamu}

TYPE  Tinfo  = char;              { Informace o polozce         }

      Titem  = record             { Vlastn prvek               }
                 key : integer;   { - klic                      }
                 info: Tinfo;     { - informace o polozce       }
               end;

      TListe    = array[1..N] of Titem;     { interni typ seznamu}
      TExtListe = File of Titem;            { externi typ seznamu}
      Tapes     = array[1..4] of TExtListe; { Typ pro 4nasobne  }
                                            { externi seznamy   }

VAR   T                 : Tapes;  { externi soubory se seznamy  }
      in1,in2,out1,out2 : integer;{ Cisla "pasku"              }
      i,j               : integer;
      item, item1       : Titem;  { jen ke kontrole vysledku   }



{ --------------------------------------------------------------}
{ Selection Sort - jen pro interni dilci seznam                 }
{ --------------------------------------------------------------}
PROCEDURE SelectionSort (VAR A: TListe; N: integer);

VAR i,j : integer; { Ukazatel do trideneho seznamu       }
    min : integer; { Index minima ve zbylem poli         }
    item: Titem;   { Pom. promenna k zamene polozek      }

BEGIN
  FOR i:=1 TO N-1 DO
    BEGIN
      { hledej minimum ve zbylem seznamu}
      min:=i;
      FOR j:=i+1 TO N DO
        IF A[j].key<A[min].key THEN min:= j;

      { zamen i-tou polozku s minimem zbyleho seznamu    }
      item   := A[min];
      A[min] := A[i];
      A[i]   := item;
    END;
END;




{--------------------------------------------------------------}
{ Protokol - Vypsani   prehledu (kartoteky) na obrazovce       }
{--------------------------------------------------------------}
PROCEDURE Protocol (var F: TExtListe);
VAR item: Titem;
BEGIN
  Reset (F);
  WHILE not(EOF(F)) DO BEGIN
                         Read(F,item);
                         Write(item.key:4);
                       END;
  WriteLn;
END;



{ --------------------------------------------------------------}
{ SwitchTapes - zamenit cisla pasku                             }
{ --------------------------------------------------------------}
PROCEDURE SwitchTapes (var T1,T2: integer);
VAR T: integer;
BEGIN
  T :=T1;
  T1:=T2;
  T2:=T ;
END;



{--------------------------------------------------------------}
{ PresetTapes - Predobsazeni dvou pasku Runy delky  N          }
{--------------------------------------------------------------}
PROCEDURE PresetTapes (VAR T, T1, T2: TExtListe);

VAR    i, imax: integer;
       A: TListe;               { interni pole k setrideni }

BEGIN
 Reset(T);
 Rewrite(T1);
 Rewrite(T2);
 WHILE not EOF(T) DO
   BEGIN

     { Obsadit prvn pasek Runem }
     i:=0;
     WHILE ((not EOF(T)) and (i<N)) DO
       BEGIN
         i:=i+1;
         Read(T,A[i]);
       END;
     imax:=i;
     SelectionSort(A,imax);
     FOR i:=1 TO imax DO Write(T1,A[i]);

     { druhy pasek obsadit Runem  }
     i:=0;
     WHILE ((not EOF(T)) and (i<N)) DO
       BEGIN
         i:=i+1;
         Read(T,A[i]);
       END;
     imax:=i;
     SelectionSort(A,imax);
     FOR i:=1 TO imax DO Write(T2,A[i]);
   END;
END;



{--------------------------------------------------------------}
{ NextTape - Voli jiny vystupni pasek                          }
{--------------------------------------------------------------}
PROCEDURE NextTape (VAR out: integer);
BEGIN
  out := out+1;
  IF out=3 THEN out:=1;
  IF out=5 THEN out:=3;
END;


{--------------------------------------------------------------}
{ TestItem - Poskytne dal polozku, aniz by zmenil pozici v souboru}
{--------------------------------------------------------------}
PROCEDURE TestItem(VAR T: TextListe; VAR item: Titem);
BEGIN
  Read (T,item); Seek(T,Filepos(T)-1);
END;



{--------------------------------------------------------------}
{ MergeRuns - Spoji dva Runy ze dvou externich vstupnich       }
{             kanalu a vypise jeden dvojnasobne dlouhy         }
{             setrideny Run  na dalsi kanal                    }
{--------------------------------------------------------------}
PROCEDURE MergeRuns( VAR T1, T2, T: TExtListe);
VAR item1, item2: Titem;
    FP: longint;

BEGIN
  WHILE (not EOF(T1) and not EOF(T2)) DO
    BEGIN
      TestItem(T1,Item1); TestItem(T2,Item2);
      IF item1.key <= item2.key THEN

        BEGIN { mansi polozku prenest z T1 do T         }
          Read  (T1,item1);
          Write (T ,item1);

          { Je-li soubor T1 nebo Run na T1 u konce, pak jeste}
          { prenest aktualni Run z T2 na konec               }
          IF not EOF(T1) THEN TestItem (T1,item);
          IF (EOF(T1) OR (item1.key>item.key))
            THEN BEGIN
                   REPEAT
                     item1 := item2;
                     TestItem(T2,item);
                     IF item.key >= item2.key
                        THEN BEGIN
                               Read (T2,item2);
                               Write(T,item2);
                             END;
                   UNTIL ((item.key<item1.key) OR (EOF(T2)));
                   Exit;
                 END;

        END
      ELSE  { mansi polozku prenest z T2 do T }
        BEGIN
          Read  (T2,item2);
          Write (T ,item2);

          { Je-li soubor T2 nebo Run na T2 u konce, pak jeste}
          { prenest aktualni Run z T1 na konec               }
          IF not EOF(T2) THEN TestItem (T2,item);
          IF (EOF(T2) OR (item2.key>item.key))
          THEN BEGIN
                 REPEAT
                   item1 := item2;
                   TestItem(T1,item);
                   IF item.key >= item1.key
                      THEN BEGIN
                             Read (T1,item1);
                             Write(T,item1);
                           END;
                 UNTIL ((item.key<item1.key) OR (EOF(T1)));
                 Exit;
               END;

        END;
    END;
END;

{---------------------------------------------------------------}
{ CopyRest - Zkopiruj zbytek souboru z T1 do T2                 }
{---------------------------------------------------------------}
PROCEDURE CopyRest (var T1, T2: TExtListe);
BEGIN
  WHILE not EOF(T1) DO BEGIN
                         Read (T1,item);
                         Write(T2,item);
                       END;
END;



{---------------------------------------------------------------}
{ Balanced_2Way_MergeSort - Externi razeni metodou              }
{                                                               }
{ Parametry:                                                    }
{                                                               }
{ T : array[1..4] of TExtListe  4 "Pasky "                      }
{                               T[1] obsahuje vstupni seznam    }
{ i : integer                   Cislo pasku s vysledkem         }
{                                                               }
{---------------------------------------------------------------}
PROCEDURE Balanced_2Way_MergeSort( VAR T: tapes; VAR i: integer);

VAR out: integer;  { aktualni vystupni pasek}

BEGIN
  { Zapis Runy delky I na pasky  T[3] a T[4] }
  PresetTapes (T[1], T[3], T[4]);

  { Prednastaveni vstupniho nebo vystupniho pasku}
  in1 :=3; in2 :=4;
  out1:=1; out2:=2;

  { Pracuj tak dlouho, dokud T[in2] nebude prazdny     }
  { T[in1] pak obsahuje setrideny seznam }
  Reset (T[in2]);
  WHILE not EOF(T[in2]) DO
    BEGIN
      out := out2; { na out2 bylo prave zapisovano     }
      Reset (T[in1]);
      Rewrite (T[out1]);
      Rewrite (T[out2]);

      { Runy se spoji z T[in1], T[in2] do   T[out]            }
      { Pricemz T[in2] obsahuje nejvyse tolik Runu jako T[i1] }
      { a je tim prvn vycerpan                               }

      WHILE not EOF(T[in2]) DO
        BEGIN
          { Zvolit jiny vystupni pasek }
          nextTape  (out); { Zvolit jiny vystupni pasek }

          { Spoji dal dva Runy vystupnich pasku }
          MergeRuns (T[in1], T[in2], T[out]);
        END;

      nextTape (out);            { Zvolit jiny vystupni pasek  }
      CopyRest (T[in1], T[out]); { event. Zkopirovat posledn Run}
      SwitchTapes (out1,in1);    { Zamenit vstup. a vystup. pasky}
      SwitchTapes (out2,in2);
      Reset (T[in2]);
    END;

  i := in1;                 { T[i] obsahuje setridenou posloupnost}
END;



{--------------------------------------------------------------}
{ SetupListe - Inicializuje kartoteku F s N nahodnymi hodnotami}
{--------------------------------------------------------------}
PROCEDURE SetupListe (var F: TExtListe; N: integer);
VAR item: Titem;
    i   : integer;

BEGIN
  Randomize;
  Rewrite (F);
  FOR I:=1 TO Nextrn DO BEGIN
                     item.key  := Random(100);
                     item.info := ' ';
                     Write(F,item);
                   END;
END;



BEGIN {Main}

  ClrScr;
  { Priradit externi kartoteky}
  Assign (T[1],'TAPE1');
  Assign (T[2],'TAPE2');
  Assign (T[3],'TAPE3');
  Assign (T[4],'TAPE4');

  FOR j:=1 TO 10 DO
    BEGIN
      { predobsadit kartoteku 1 s nesetridenym seznamem}
      SetupListe (T[1],10);
      Protocol  (T[1]);

      { Razeni    }
      Balanced_2Way_MergeSort(T,i);

      { Kontrola razeni   }
      Protocol(T[i]);

      Reset (T[i]);
      Read(T[i],item);

      WHILE not(EOF(T[i])) DO BEGIN
                                Read(T[i],item1);
                                IF (not(item.key<=item1.key))
                                   THEN BEGIN
                                          WriteLn ('Error detected');
                                          Exit
                                        END
                                ELSE item:=item1;
                              END;
    WriteLn ('Seznam ', j, '  setriden !');
  END;
  Close(T[i]) ;
END.




