program Databaze;
uses Crt,dos,strings;
const delky : array[0..6] of byte=(30,20,40,40,6,6,6); {delky jednotlivych polozek v zaznamu}
      filename='data.dat';{nazev souboru s daty}
      moz : array[65..66] of string[3]=('ANO','NE ');{moznosti u zajmovych oblasti}
      zajmy_n : array[1..6] of string[40]=
               ('Obuv               : ','Osaceni            : ','Domaci spotrebice  : ',
                'Cistici prostredky : ','Elektronika        : ','Zahradni pomucky   : ');
                {nazvy zajmovych oblasti}
type adr_type=record                        {adresa}
               mesto,ulice  : string[40];
               cp,psc       : string[6]
              end;
     uk=^polozka;
     z_t=string[6];
     polozka=record                         {jedna polozka v zaznamu}
              prijmeni  : string[30];
              jmeno     : string[20];
              adr       : adr_type;
              zajmy     : z_t;
              dalsi     : uk;
             end;
      uk_hl=^hl_pol;               {polozka pro hledani}
      hl_pol=record       {polozka pro seznam vysledku hledani, ukazuje dopredu i dozadu}
              ukaz   : uk;
              dalsi  : uk_hl;
              minuly : uk_hl;
             end;
var pol,prvni      : uk;              {prvni - ukazatel na zacatek seznamu}
    num            : integer; {pocet polozek}
    f              : file of polozka;

function fileexists(s : String): boolean;     {zjisti, zda existuje zadany soubor}
var f : file;
begin
{$I-} {vypne kontrlou chyb}
 assign(f,s);
 filemode:=0;
 reset(f);
 close(f);
{$I+}
 if ioresult=0 then fileexists:=true else fileexists:=false;
end;

function porovnej(a,b : string) : boolean; {porovna dva retezce, nezalezi na velikosti pismen}
begin
 porovnej:=false;
 if length(a)=length(b) then
  if strlicomp(@a,@b,length(a))=0 then porovnej:=true;
end;

procedure initdata; {pokud nalezne soubor s daty, tak je nacte do spojoveho seznamu}
begin
 if fileexists(filename) then
  begin
   assign(f,filename);
   filemode:=2;
   reset(f);
   num:=0;
   while not eof(f) do          {nacita...}
    begin
     inc(num);
     if num>1 then              {pripad, ze to neni prvni polozka...}
      begin
       new(pol^.dalsi);
       pol^.dalsi^.dalsi:=nil;
       read(f,pol^.dalsi^);
       pol:=pol^.dalsi;
       end
      else
       begin                         {a ze je...}
        new(pol);
        pol^.dalsi:=nil;
        read(f,pol^);
        prvni:=pol;
       end;
    end;
  end;
end;

procedure closedata;      {na konci ulozi seznam do souboru}
begin
 assign(f,filename);
 rewrite(f);
 pol:=prvni;
 repeat
  write(f,pol^);
  pol:=pol^.dalsi;
 until pol=nil;
 close(f);
end;

procedure settext(b : byte);       {nastavi barvu textu 0 - normalin, 1 - inverzni}
begin
 if b=1 then
  begin
   textcolor(0);
   textbackground(15);
  end
 else
  begin
   textcolor(15);
   textbackground(0);
  end;
end;

procedure getchar(var c : integer); {nascte klavesu, umoznuje nacist i rozsirene}
var r : registers;       {klavesu jako jsou sipky ci eFka}
begin
 with r do
  begin
   ax:=0;
   intr($16,r);     {sluzba BIOS, vrati kod klavesy v AX}
   if al>0 then c:=al else c:=ax;
  end;
end;

procedure beep;         {zapipa}
begin
 sound(200);
 delay(20);
 nosound;
end;

procedure getstring(var s : string;l : byte;var stat : integer);
{nacte retezec od delce l, umoznuje pouziti Backspace, vraci kody ve stat}
{to proto, aby slo zjistit, zda behem zadavani byl zmacknut Esc, eFko, atd...}
var a,x,y : byte;   {a je dosezena delka retezce}
    c,i   : integer;
    p     : boolean;
begin
 a:=0;
 p:=true;
 stat:=0;
 s:='';
 while p do
  begin
   getchar(c);
   case c of
     8 : begin                      {zmacknuti backspace}
          if a>0 then
           begin
            dec(a);        {zmensime delku a smazeme posledni znak an obrazovce}
            s[0]:=chr(a);
            write(chr(c));
            write(' ');
            write(chr(c));
           end
          else beep;
         end;
    27 : begin                                      {Esc}
          s:='';
          p:=false;
          if a>0 then stat:=10 else stat:=100;
         end;
    13 :  p:=false;                                      {Enter}
    $5000,$4800,$4200,$4d00,$4b00,$4f00,$4700,$3f00 : begin     {sipky,eFka,home,end}
                                                       p:=false;
                                                       stat:=c;
                                                      end;
    else
     if (c<256) and (a<l) then {kontrola c, kdyz c>255 tak byla zmacknuta rozsirena klavesa}
      begin               {tedy ne pismeno}
       if a=0 then           {pokud to bylo prvni pismeno}
        begin
         x:=wherex;         {schovame si pozici kurzoru}
         y:=wherey;
         for i:=1 to l do write(' ');       {prepiseme dosavadni text}
         gotoxy(x,y);
        end;
       s:=s+chr(c);
       write(chr(c));
       inc(a);
      end
     else if p then beep;
    end;
  end;
end;

{$f+}
procedure edit_zajmy(var z : z_t);   {editace zajmovych oblasti}
{zajmy jsou ulozeny jako string s sesti znaky, co znak to zajem}
{pokud je znak A - zajem ano, B - zajem ne}

const max_pol=6;
var zaloha : array[1..80*50] of byte; {sem schovame obsah obrazovky,80*25 znaku po 2bytech}
    i,c                      : integer;
    p                        : boolean;
    curr_pol                 : byte;
    s                        : string;
begin
 for i:=1 to 80*50 do zaloha[i]:=mem[$b800:i]; {schovavame}
 s:=z;
 settext(0);
 clrscr;
 settext(1);
 gotoxy(1,1);
 writeln('                            Editace zajmovych oblasti                           ');
 gotoxy(1,24);
 writeln(' Pouzij sipky doleva, doprava, nebo Enter             F8 - pouzij  Esc - konec ');
 settext(0);
 gotoxy(1,4);
 for i:=1 to 6 do writeln(zajmy_n[i],moz[ord(z[i])]);
 settext(1);
 gotoxy(1,4);
 writeln(zajmy_n[1],moz[ord(z[1])]); {vypisem nazev zajmove oblasti a k ni ano nebo ne}
 p:=true;
 curr_pol:=1;
 while p do  {klasickej cyklus pro chozeni po polozkach jako v menu, podrobneji v proc. menu}
  begin
   getchar(c);
   settext(0);
   gotoxy(1,3+curr_pol);
   writeln(zajmy_n[curr_pol],moz[ord(z[curr_pol])]);
   case c of
    $5000 : if curr_pol<max_pol then inc(curr_pol) else curr_pol:=1; {sipka nahoru}
    $4800 : if curr_pol>1 then dec(curr_pol) else curr_pol:=max_pol;  {sipka dolu}
    13,$4b00,$4d00,32 : if z[curr_pol]='A' then z[curr_pol]:='B' else z[curr_pol]:='A';
     {prepinani ano/ne, sipky do stran, enter, space}
    27    : begin     {Esc}
             p:=false;
             z:=s;
            end;
    $4200 : p:=false;      {F8}
   end;
   settext(1);
   gotoxy(1,3+curr_pol);
   writeln(zajmy_n[curr_pol],moz[ord(z[curr_pol])]);
  end;
 for i:=1 to 80*50 do mem[$b800:i]:=zaloha[i]; {Obnoveni puvodniho obsahu obrazovky}
 settext(0);
end;

procedure edit(pol : uk;var stav : byte);{nejdulezitejsi, zajistuje editaci a prohlizeni polozek}
const max_pol=5;
var s             : string;
    stat,p1,p2,i  : integer;
    p             : boolean;
    curr_pol      : byte;
begin
 with pol^ do
  begin
   writeln('Prijmeni      :  ',prijmeni);
   writeln('Jmeno         :  ',jmeno);
   with adr do
    begin
     writeln('Mesto         :  ',mesto);
     writeln('Ulice         :  ',ulice);
     writeln('Cislo domu    :  ',cp);
     writeln('PSC           :  ',psc);
    end;
  end;
 gotoxy(1,12);
 for i:=1 to 6 do writeln(zajmy_n[i],moz[ord(pol^.zajmy[i])]);
 p:=true;
 curr_pol:=0;
 with pol^ do
  while p do
   begin
    gotoxy(18,4+curr_pol);
    settext(1);
    stat:=stav;
    getstring(s,delky[curr_pol],stat); {zavola nacteni retezce}
    p1:=curr_pol;
    case stat of
     0,$5000 : begin              {enter, sipka dolu}
                p1:=curr_pol;
                curr_pol:=(curr_pol+1) mod (max_pol+1);
               end;
     $4800   : begin                          {sipka nahoru}
                if curr_pol>0 then dec(curr_pol) else curr_pol:=max_pol;
               end;
     $4200   : begin                  {F8}
                if (prijmeni='') and (stav=5) then beep else
                 begin
                  stav:=0;
                  p:=false;
                 end;
               end;
      100    : begin                      {ESC - bez ulozeni}
                p:=false;
                stav:=10;
               end;
     $3f00   : begin                   {F5 - editace zajmu}
                edit_zajmy(zajmy);
                gotoxy(1,12);
                for i:=1 to 6 do writeln(zajmy_n[i],moz[ord(zajmy[i])]);
               end;
     $4b00   : if stav=5 then  {sipka doleva, pouziva se jen pro prohlizeni vysledku hledani}
               begin     {proto ta kontrola stav, pokud tahle procedura neni volana z hledani,}
                p:=false;     {je stav=0}
                stav:=30;
               end;
     $4d00   : if stav=5 then {sipka doprava, viz vyse}
               begin
                p:=false;
                stav:=40;
               end;
     $4700   : if stav=5 then     {home a end}
               begin
                p:=false;
                stav:=50;
               end;
     $4f00   : if stav=5 then
               begin
                p:=false;
                stav:=60;
               end;
    end;
    settext(0);
    gotoxy(18,4+p1);
    write('                                         ');
    gotoxy(18,4+p1);
    case p1 of                           {prirazeni retezce s do spravny promeny pro aktualni radek}
     0 : begin                          {s nesmi byt prazdne}
          if s<>'' then prijmeni:=s;
          write(prijmeni);
         end;
     1 : begin
          if s<>'' then jmeno:=s;
          write(jmeno);
         end;
     2 : begin
          if s<>'' then adr.mesto:=s;
          write(adr.mesto);
         end;
     3 : begin
          if s<>'' then adr.ulice:=s;
          write(adr.ulice);
         end;
     4 : begin
          if s<>'' then adr.cp:=s;
          write(adr.cp);
         end;
     5 : begin
          if s<>'' then adr.psc:=s;
          write(adr.psc);
         end;
    end;
    gotoxy(18,4+curr_pol);
    settext(1);
    case curr_pol of
     0 : write(prijmeni);
     1 : write(jmeno);
     2 : write(adr.mesto);
     3 : write(adr.ulice);
     4 : write(adr.cp);
     5 : write(adr.psc);
    end;
   end;
 settext(0);
end;

procedure zadavej;      {zadani novych dat}
var stat : byte;
    novy : uk;
    p    : boolean;
begin
 p:=true;
 while p do
  begin
   clrscr;
   settext(1);
   writeln('                                  Zadavani dat                                  ');
   gotoxy(1,24);
   writeln('  Pouzij Esc, sipky, Enter, F5(pro editaci zajmu)       Pro ulozeni pouzij F8  ');
   settext(0);
   gotoxy(1,4);               {nova polozka + vynulovani}
   new(novy);
   with novy^ do
    begin
     prijmeni:='';
     jmeno:='';
     adr.mesto:='';
     adr.ulice:='';
     adr.cp:='';
     adr.psc:='';
     zajmy:='BBBBBB';                       {vsechny zajmy jsou ne, viz edit zajmy}
     dalsi:=nil;
    end;
   stat:=0;
   edit(novy,stat); {editace nove polozky}
   if stat=10 then        {byl zmacknut Esc, nova polozka se nekona, tak ji zrusime}
    begin
     dispose(novy);
     p:=false;
    end
   else
    begin
     inc(num);
     if num=1 then           {jinak zaclenime novou polozku do seznamu}
     begin
      pol:=novy;
      prvni:=pol;
     end
     else
      begin
       new(pol^.dalsi);
       pol^.dalsi:=novy;
       pol:=pol^.dalsi;
       pol^.dalsi:=nil;   {posledni polozka ukazuje na nil}
      end;
    end;
 end;
end;

procedure hledej;  {vyhleda polozky podle zadane masky}
var maska,poloz         : uk;
    hled,prv_hl,pos_hl  : uk_hl;
    num_hl,c,i          : integer;
    p,p2,p3             : boolean;
    stat                : byte;
begin
 p2:=true;
 while p2 do
  begin
   clrscr;
   settext(1);
   writeln('                     Hledani dat - vypln masku pro hledani                     ');
   gotoxy(1,24);
   writeln('  Pouzij Esc, sipky, Enter, F5(editace zajmu)          Pro hledani pouzij F8   ');
   settext(0);
   gotoxy(1,4);
   new(maska);      {vytvorime prazdnou masku}
   with maska^ do
    begin
     prijmeni:='';
     jmeno:='';
     adr.mesto:='';
     adr.ulice:='';
     adr.cp:='';
     adr.psc:='';
     zajmy:='AAAAAA';
    end;
   edit(maska,stat);          {naeditujeme do ni nove udaje}
   if stat=0 then
    begin
     num_hl:=0;
     poloz:=pol;
     pol:=prvni;
     repeat
      p:=true;
      with maska^ do   {a porovname postupne se vsema polozkama}
       begin
        if (not porovnej(prijmeni,pol^.prijmeni)) and (prijmeni<>'') then p:=false;
        if (not porovnej(jmeno,pol^.jmeno)) and (jmeno<>'') then p:=false;
        if (not porovnej(adr.mesto,pol^.adr.mesto)) and (adr.mesto<>'') then p:=false;
        if (not porovnej(adr.ulice,pol^.adr.ulice)) and (adr.ulice<>'') then p:=false;
        if (not porovnej(adr.cp,pol^.adr.cp)) and (adr.cp<>'') then p:=false;
        if (not porovnej(adr.psc,pol^.adr.psc)) and (adr.psc<>'') then p:=false;
        p3:=false;
        for i:=1 to 6 do if (zajmy[i]=pol^.zajmy[i]) and (zajmy[i]='A') then p3:=true;
        if not p3 then p:=false;
        if p then
         begin                {vysledky ukladame do samostatneho spojoveho seznamu}
          inc(num_hl);
          if num_hl=1 then
           begin
            new(hled);
            with hled^ do
             begin
              minuly:=nil;
              dalsi:=nil;
              ukaz:=pol;
             end;
            prv_hl:=hled;
           end
           else
           begin
            new(hled^.dalsi);
            with hled^.dalsi^ do
             begin
              ukaz:=pol;
              dalsi:=nil;
              minuly:=hled;
             end;
            hled:=hled^.dalsi;
           end;
         end;
        pol:=pol^.dalsi;
       end;
     until pol=nil;
     pol:=poloz;
     dispose(maska);
     clrscr;        {zobrazime vsechny nalezene polozky}
     settext(1);
     writeln('                          Hledani dat - vysledek                               ');
     gotoxy(1,24);
     writeln('  Zmackni libovolnou klavesu...                                                ');
     gotoxy(23,10);
     writeln('Ŀ');
     gotoxy(23,11);
     writeln(' Pocet nalezenych polozek :      ');
     gotoxy(23,12);
     writeln('');
     gotoxy(52,11);
     write(num_hl);
     settext(0);
     while not keypressed do;
     readkey;
     if num_hl>0 then
      begin
       p:=true;
       pos_hl:=hled;
       hled:=prv_hl;
       while p do             {prochazime seznamem nalezenych polozek...}
        begin
         clrscr;
         settext(1);
         writeln('                          Hledani dat - vysledek                               ');
         gotoxy(1,24);
         writeln('  Pouzij sipky, Home, End                          Pro ukonceni pouzij Esc     ');
         settext(0);
         gotoxy(1,4);
         maska:=hled^.ukaz;
         stat:=5;
         edit(maska,stat);    {vsimni si, ze volame edit se stat=5, viz popis vyse}
         case stat of      {ve stat se nam vrati zmacknute klavesy behem prohlizeni}
          10,100 : p:=false; {Esc}
          30 : if hled^.minuly<>nil then hled:=hled^.minuly else beep;{sipka doleva, vratime se o polozku zpet}
          40 : if hled^.dalsi<>nil then hled:=hled^.dalsi else beep;{sipka doprava, jdeme o polozku dal}
          50 : hled:=prv_hl; {Home}
          60 : hled:=pos_hl; {End}
         end;
        end;
      end;
    end
    else p2:=false;
  end;
end;
{$f-}

procedure menu;   {pocatecni menu}
const   menu_n=3; {pocet radky nabidky}
        menu:array[0..menu_n] of string[40]=(' Zadavani dat             ',' Vyhledavani a oprava dat ',
                                             ' Specialni mod            ',' Konec                    ');
        proc:array[0..menu_n-1] of procedure=(zadavej,hledej,nil);
var i,c              : integer;
    p                : boolean;
    curr_pol          : byte; {ukazuje na aktualni radek v menu}

procedure ramecek;     {ramecek pro menu}
var i : integer;
begin
 gotoxy(1,9);
 writeln('                               Ŀ');
 for i:=0 to menu_n do writeln('                                                         ');
 writeln('                               ');
end;

procedure xmenu(a : byte);  {napise polozky menu, a-tou napise inverzne}
var i : integer;
begin
 settext(0);
 for i:=0 to menu_n do
  begin
   gotoxy(33,10+i);
   write(menu[i]);
  end;
 if a<10 then
  begin
   settext(1);
   gotoxy(33,10+a);
   write(menu[a]);
  end;
 settext(0);
end;

begin
 clrscr;
 settext(0);
 ramecek;       {nakresi menu a zvyrazni prvni (nultou) polozku}
 p:=true;
 curr_pol:=0;
 xmenu(curr_pol);
 while p do
  begin
   getchar(c);
   case c of   {pruchod nabidkou}
    $5000 : begin                {sipka dolu}
             curr_pol:=(curr_pol+1) mod (menu_n+1);
             xmenu(curr_pol);
            end;
    $4800 : begin                 {sipka nahoru}
             if curr_pol=0 then curr_pol:=menu_n else dec(curr_pol);
             xmenu(curr_pol);
            end;
       13 : begin                   {enter}
             if curr_pol<menu_n then
              begin
               proc[curr_pol];
               clrscr;
               curr_pol:=0;
               ramecek;
               xmenu(curr_pol);
              end
             else p:=false;
            end;
       27,$4200 : p:=false;        {Esc a F8}
   end;
  end;
 settext(0);
end;

begin
 initdata;             {nacte data}
 menu;                  {spusti se }
 if num>0 then closedata;  {zapise data, pokud mame nejake polozky}
 clrscr;
end.
