{ --------------------------------------------------------------}
{ Ramcovy program metody razeni                                 }
{ --------------------------------------------------------------}
PROGRAM Main;

USES CRT, DOS;

CONST N      = 10;                       { Velikost seznamu     }
      KeyLen = 3;                        { Delka klice          }

TYPE  Tinfo  = char;                     { Informace o polozce  }

      Titem  = record                    { Vlastn prvek        }
                 key : integer;          { - klic               }
                 info: Tinfo;            { - informace o polozce}
               end;

      TListe = ARRAY [1..N] OF Titem;    { typ pro seznam       }

VAR   A   : TListe;                      { seznam k setrideni   }
      i,j : integer;


{---------------------------------------------------------------}
{ Razeni prihradkovym delenim                                   }
{---------------------------------------------------------------}
{ Klice jsou typu integer. Jako klic je pouzivano jen poslednich}
{ n decimalnich  mist.                                          }
{---------------------------------------------------------------}
PROCEDURE FachVerteilen (VAR A : TListe;Keylen:INTEGER);

VAR i,j,k  : integer;          { Ukazatele na rozdeleni         }
    AA     : TListe;           { Pomocne pole pro prihradky     }
    F      : ARRAY [0..9] OF integer; { Ukazatel  na prihradky  }
    weight : integer;          { hodnost akt. pozice cifry      }


{---------------------------------------------------------------}
{ Funkce Z doda klici cifru na aktualni pozici                  }
{---------------------------------------------------------------}

FUNCTION Z(VAR b: integer): integer;
BEGIN
  Z:=(b DIV weight MOD 10);
END;


BEGIN { Prihradkove deleni}
  weight:=1; { Vaha prvniho ciferniho mista    }

  FOR i:=0 TO KeyLen-1 DO
    BEGIN { Prochazeni pozice cifry i     }

    { Urcit velikost prihradky}
      FOR j:=0 TO 9 DO F[j]:=0;
      FOR j:=1 TO N DO BEGIN
                         k    := Z(A[j].key);
                         F[k] := F[k]+1;
                       END;

    { Urcit pocatecni pozice prihradek     }
      F[9] := N+1-F[9];
      FOR j:=8 DOWNTO 0 DO F[j]:=F[j+1]-F[j];

    { Rozdeleni }
      FOR j:=1 TO N DO BEGIN
                         k        := Z(A[j].key);
                         AA[F[k]] := A[j];
                         F [k]    := F[k]+1;
      END;

    { Faze sberu  }
      FOR j:=1 TO N DO A[j]:=AA[j];

    { Pripravit hodnost dalsiho ciferniho mista }
      weight:=10*weight;

    END;
END;




BEGIN {Main}

ClrScr;
Randomize;
FOR j:= 1 TO 100 DO
  BEGIN
  { Predobsadit a vypsat seznam    }
    FOR i:=1 TO N DO A[i].key:=Random(1000);
    WriteLn ('Seznam',j:4,': ');
    Write (' ':10);
    FOR i:=1 TO N DO Write (A[i].key:5); WriteLn;

  { Vyvolani radiciho algoritmu:                                }
  { ----------------------------                                }
    FachVerteilen(A);

  { Vypsat serazeny seznam  }
    Write (' ':10);
    FOR i:=1 TO N DO Write (A[i].key:5); WriteLn;

  { Kontrola razeni   }
    FOR i:=1 TO N-1 DO IF (not(A[i].key<=A[i+1].key)) THEN
      BEGIN
        WriteLn ('Error detected');
        Exit
      END;
  END;
END.

