{--------------------------------------------------------}
{ Ramcovy program metody razeni                          }
{ -------------------------------------------------------}
PROGRAM Main;

USES CRT;

CONST N = 15;                     { Velikost seznamu     }

TYPE  Tinfo  = char;              { Informace o polozce  }

      Titem  = record             { Vlastn prvek        }
                 key : integer;   { - klic               }
                 info: Tinfo;     { - informace o polozce}
               end;

      TListe = ARRAY [0..N] OF Titem;  { pole seznamu    }

VAR   A   : TListe;               { seznam k setrideni   }
      i,j : integer;

{---------------------------------------------------------------}
{ HeapSort - Razeni metodou Heap Sort                           }
{---------------------------------------------------------------}
PROCEDURE HeapSort (VAR A: TListe; N: INTEGER);

VAR  left, right : INTEGER;    { Hranice zbyleho seznamu }
     item        : Titem;      { Pomocna promenna k zamene}


{---------------------------------------------------------------}
{ Sestup : korenovy prvek hromady se pohybuje dolu podel vetsiho}
{          uzlu stromu                                          }
{          Parametr:   A: pole s hromadou                       }
{                      r: prava mez hromady                     }
{                      l: leva mez hromady                      }
{
{---------------------------------------------------------------}
PROCEDURE Descent;

VAR i, j: INTEGER;      { Pozice Ukazatele pro sestup           }
    item : Titem;       { Pomocny prvek pro zamenu              }


BEGIN { Descent }
  i:=left;              { i ukazuje na korenovy prvek           }
  j:=2*I;               { j ukazuje na syny polozky i           }
  item:=A[I];           { zapamatovat sestupujici polozku       }

  { nech sestupovat korenovy prvek}
  WHILE j<=right DO
  BEGIN
    { Vyhledej vetsiho syna          }
    IF ( j<right ) THEN IF A[j].key < A[j+1].key THEN j:=j+1;

    IF (item.key >= A[j].key)
       { V pripade, ze sestupujici prvek je vetsi nez vsechny   }
       { pod nim, ukonci sestupovani                            }
       THEN j:=right+1  { Nastav ukoncovaci podminku pro WHILE  }

       { Jestlize jsou pod nim jeste nejake vetsi, nech posun   }
       { nizsi polozku nahoru                                   }
       ELSE BEGIN
              A[i]:=A[J];
              i := j;   { nastav i na pozici, ktera se uvolnila }
              j :=2*i;  { ukaz na prvniho syna                  }
            END
  END;

  { Sestup ukoncen: Zapis sestupujici polozku na cilovou pozici }
  A[i]:=item;
END; {Descent}

BEGIN
{ Nastav left na prvni otcovsky uzel dolnich urovni             }
  left  := (N DIV 2)+1;  { left  ---> nejspodnejsi otcovksy uzel}
  right := N;            { right ---> na pravy konec seznamu    }

{ Vystavet hromadu}
{ ----------------}
  WHILE (left>1) DO
  BEGIN
    left:=left-1;        { left ---> na dalsi koren             }
    Descent;              { nechat sestoupit aktualni koren      }
  END;

{ Razeni }
{ --------- }
  WHILE right>1 DO
  BEGIN
    { Zamenit koren hromady s poslednim prvkem zbyleho seznamu  }
    item     := A[left];
    A[left]  := A[right];
    A[right] := item;

    { Ve zbylem seznamu obnovit podminku hromady                }
    right := right-1;
    Descent;
  END;
END;



BEGIN {Main}


Randomize;
FOR j:= 1 TO 100 DO
  BEGIN
    { Predobsadit a vypsat seznam}
    FOR i:=1 TO N DO A[i].key:=Random(100);
    WriteLn ('Seznam',j:4,': ');

    { Razeni }
    HeapSort(A,N);

    { Kontrola razeni }
    FOR i:=1 TO N-1 DO IF (not(A[i].key<=A[i+1].key)) THEN
      BEGIN
        WriteLn ('Error detected');
        Exit
      END;
  END;
END.


