{--------------------------------------------------------}
{ Ramcovy program metody razeni                          }
{ -------------------------------------------------------}
PROGRAM Main;

USES CRT;

CONST N = 10;                     { Velikost seznamu     }

TYPE  Tinfo  = char;              { Informace o polozce  }

      Titem  = record             { Vlastni prvek        }
                 key : integer;   { - klic               }
                 info: Tinfo;     { - informace o polozce}
               end;

      { Specialne pro prirozeny Mergr Sort navesit na    }
      { seznam pridavny prvek!                           }
      { ----------------------------------------------   }
      TListe = ARRAY [0..N+1] OF Titem;  { Pole seznamu  }


VAR   A   : TListe;               { seznam k setrideni   }
      i,j : integer;



{--------------------------------------------------------}
{ Spojeni dvou uz roztridenych seznamu                   }
{--------------------------------------------------------}
PROCEDURE Merge (VAR A: TListe; left, center, right: integer);

VAR AA : TListe;         { Pomocne pole pro roztrideny seznam}
    h, i,j,k: integer;   { Ukazatel  na smesovani               }

BEGIN
  i:=left;        { i --> dalsi prvek leve posloupnosti      }
  j:=center+1;    { j --> dalsi prvek prave posloupnosti     }
  k:=left;        { k --> prvni Pozice vysledneho seznamu  }

  WHILE (i<=center) AND (j<=right) DO
    BEGIN
      IF (A[i].key <= A[j].key) THEN BEGIN
                                       AA[k]:=A[i];
                                       i:=i+1;
                                     END
                                ELSE BEGIN
                                       AA[k]:=A[j];
                                       j:=j+1;
                                     END;
      k:=k+1;
    END;

  { kopirovat pravy resp. levy zbyly seznam do vysledneho     }
  IF i>center THEN FOR h:=j TO right  DO AA[k+h-j]:=A[h]
              ELSE FOR h:=i TO center DO AA[k+h-i]:=A[h];

  { roztrid seznam zpet do originalniho pole}
  FOR h:=left TO right DO A[h]:=AA[h]
END;






{--------------------------------------------------------}
{ Rekurzivni dvoucestna metoda Merge Sort                }
{--------------------------------------------------------}
PROCEDURE MergeSort (VAR A: TListe; left, right: integer);

VAR center : integer;     { Ukazatel do stredu       }

BEGIN
  IF left<right { jen seznamy s nejmene 2 prvky!}
    THEN BEGIN
         { Rozdel na dve pulky   }
           center:=(left+right) DIV 2;

         { Roztrid obe pulky     }
           mergesort (A, left, center);
           mergesort (A,center+1,right);

         { Spoj obe pulky        }
           merge (A,left,center,right);
         END
END;




{--------------------------------------------------------}
{ Cista dvoucestna metoda Merge Sort                     }
{--------------------------------------------------------}
PROCEDURE StraightMergeSort (VAR A: TListe; left, right: integer);

VAR center : integer;     { Ukazatel do stredu       }
    size   : integer;     { Delka seznamu            }
    l,c,r  : integer;

BEGIN
  size :=1;    { pak smichat dilci seznamy delky 1   }

  WHILE (size<right-left+1) DO
    BEGIN        { Spojeni seznamu delky size }
      r:=left-1; { r-Ukazatel  nastavit ped celkovy seznam }

      WHILE (r+size<right) DO
        BEGIN { dokud nemame vice nez jednu castecnou posloupnost}
          l:=r+1;         { levy okraj prvn posloupnosti}
          c:=l+size-1;    { pravy okraj prvn posloupnosti}

          IF c+size<=right  THEN r:=c+size { pravy okraj }
                            ELSE r:=right; { 2.posloupnosti}

          Merge (A,l,c,r);  { Spojit!                    }
        END;

      { Vsechny castecne posloupnosti delky size spojeny }
      { dal dilci seznamy jsou dvojnasobne velke          }
        size := 2*size;
    END;
END;




{--------------------------------------------------------}
{ Prirozena dvoucestna metoda Merge Sort                 }
{--------------------------------------------------------}
PROCEDURE NaturalMergeSort (VAR A: TListe; left, right: integer);

VAR center : integer;     { Ukazatel do stredu       }
    size   : integer;     { Delka seznamu            }
    l,c,r  : integer;

BEGIN
  REPEAT
    r:=left-1;   { r-Ukazatel  inicializovat  }
    WHILE r<right DO
      BEGIN
       { levy okraj prvn posloupnosti}
         l:=r+1;

       { Zjisti maximalni uz rodtridenou castecnou posloupnost}
         c:=l;
         WHILE (c<right) AND (A[c].key <= A[c+1].key) DO c:=c+1;

       IF c<right THEN
         { Vysetrit maximalni uz roztrideny dilci seznam       }
         { a oba dva spojit                                    }
         BEGIN
           r:=c+1;
           WHILE (r<right) AND (A[r].key<=A[r+1].key) DO r:=r+1;
           Merge (A,l,c,r)
         END
       ELSE
         r:=c;  { vpravo uz nemame zadny dilci seznam      }
      END
  UNTIL l=left  { l se uz od   (**) nezmenilo, tj.       }
                { cely seznam tvori run !                 }
END;




BEGIN {Main}

Randomize;
FOR j:= 1 TO 100 DO
  BEGIN
    { Predobsadit a vypsat seznam}
    FOR i:=1 TO N DO A[i].key:=Random(100);
    WriteLn ('Liste',j:4,': ');
    Write (' ':10);
    FOR i:=1 TO N DO Write (A[i].key:5); WriteLn;

    { Razeni }
    { ------ }
    { MergeSort         (A,1,N);   }
    { StraightMergeSort (A,1,N);   }

      NaturalMergeSort  (A,1,N);


    { vypsat seznam serazene }
    Write (' ':10);
    FOR i:=1 TO N DO Write (A[i].key:5); WriteLn;

    { Kontrola razeni }
    FOR i:=1 TO N-1 DO IF (not(A[i].key<=A[i+1].key)) THEN
      BEGIN
        WriteLn ('Error detected');
        Exit
      END;
  END;
END.
