
{ --------------------------------------------------------------}
{ Ramcovy program pro hledani retezcu                           }
{ --------------------------------------------------------------}
PROGRAM Main;

USES  CRT, DOS;

CONST Smax=80;                 { maximalni delka text. stringu  }
      Pmax=100;                { maximalni delka vzoru          }
VAR tstring : STRING;          { String k prohledani            }
    pattern : STRING;          { hledany znakovy vzor           }
    next    : ARRAY[1..Pmax] OF integer; { Pole ukazatelu na dal}
    pos     : integer;
    i, j    : integer;

{---------------------------------------------------------------}
{ Primy algoritmus hledani vzoru                                }
{---------------------------------------------------------------}
FUNCTION SearchDirect (s, p: STRING) : integer;

VAR N     : integer;    { Delka stringu     }
    M     : integer;    { Delka vzoru       }
    i, j  : integer;
    found : boolean;

BEGIN
  N:=length(s);
  M:=length(p);
  FOR i:=1 TO N-M+1 DO
    BEGIN
      found:=TRUE;
      FOR j:=1 TO M DO
        IF s[i+j-1]<>p[j] THEN found:=FALSE;
      IF found THEN  BEGIN
                       SearchDirect:=i;
                       Exit
                     END;
    END;
  SearchDirect:=0;
END;


{---------------------------------------------------------------}
{ Knuth-Morris-Prattuv algoritmus hledani vzoru                 }
{---------------------------------------------------------------}
PROCEDURE InitNext(p: STRING);

VAR i, j : integer;
    M    : integer;

BEGIN
  M:=length(p);

  i:=1;
  j:=0;
  next[i]:=0;

  REPEAT
    IF (p[i]=p[j]) OR (j=0) THEN BEGIN
                                   i:=i+1;
                                   j:=j+1;
                                   next[i]:=j;
                                 END
                            ELSE j:=next[j];
    UNTIL (i>M);
END;

FUNCTION Search_KMP (s, p: STRING) : integer;

VAR N     : integer;    { Delka stringu     }
    M     : integer;    { Delka vzoru       }
    i, j  : integer;

BEGIN
  N:=length(s);
  M:=length(p);

  InitNext(p);

  i:=1;
  j:=1;
  REPEAT
    IF (s[i]=p[j]) OR (j=0) THEN BEGIN
                                   i:=i+1;
                                   j:=j+1;
                                 END
                            ELSE j:=next[j];
  UNTIL (j>M) OR (i>N);

  IF j>M THEN Search_KMP :=i-M
         ELSE Search_KMP :=0;

END;





BEGIN {Main}
  { vyrobit textovy retezec a vzor }
  Randomize;
  tstring:='';
  FOR pos:=1 TO Smax DO tstring:=tstring+char(32+random(96));
  ClrScr;
  Writeln ('Cisla pozic:');
  Write ('         ');
  For i:=1 TO 7 DO FOR j:=1 TO 10 DO Write (i);write('8');
  For i:=0 TO 7 DO Write ('1234567890'); WriteLn;
  Writeln ('Textovy retezec:');
  WriteLn (tstring);
  Write ('Vzor = '); ReadLn(pattern);
  { hledani vzoru }
  pos := Search_KMP(tstring,pattern);

  { Zobrazit vysledek }
  IF pos<>0
    THEN WriteLn(' Vzor  ',pattern, ' nalezen na pozici    ',pos)
    ELSE WriteLn(' Vzor  ',pattern, ' nenalezen.');
  ReadLn;
END.



