{ --------------------------------------------------------------}
{ Ramcovy program metody razeni                                 }
{ --------------------------------------------------------------}
PROGRAM Main;

USES CRT, DOS;

CONST N      = 8;                        { Velikost seznamu     }
      KeyLen = 7;                        { Delka klice          }

TYPE  Tinfo  = char;                     { Informace o polozce  }

      Titem  = record                    { Vlastn prvek        }
                 key : integer;          { - klic               }
                 info: Tinfo;            { - informace o polozce}
               end;

      { Pole pro seznam mus byt o jeden prvek prodlouzeno      }
      { kvuli pascalske kontrole rozsahu. Obsah A[N+1] libovolny}
      TListe = ARRAY [1..N+1] OF Titem;

VAR   A   : TListe;                      { seznam na trideni    }
      i,j : integer;



{---------------------------------------------------------------}
{ Radix Exchange Metoda razeni                                  }
{                                                               }
{---------------------------------------------------------------}
{ Klice jsou cela cisla, kter jsou interpretovana jako         }
{ binarni. Je pouzivano jen poslednich n bitovych pozici        }
{ jako    klic.                                                 }
{---------------------------------------------------------------}

PROCEDURE RadixExchange (VAR A      : TListe;    { Celkovy seznam}
                         left, right: integer;   { Meze         }
                         n          : integer);  { Delka klice  }

VAR i,j  : integer;                 { Ukazatele na rozdeleni    }
    item : TItem;                   { Pomocne pole na zamenu    }

FUNCTION Z(VAR b: integer; n: integer): integer;
BEGIN
  Z:=(b SHR (n-1) AND $0001);
END;

BEGIN
  IF (left<right) THEN        { k dispozici nejmene dve polozky }
    BEGIN
      i:=left -1;
      j:=right+1;

      REPEAT
        REPEAT i:=i+1
          UNTIL (Z(A[i].key,n)=1) OR (i>=j);  { i probiha}
        REPEAT j:=j-1
          UNTIL (Z(A[j].key,n)=0) OR (i>=j);  { j probiha}

        IF i<j THEN { zamen      A[i]  s  A[j] }
          BEGIN
            item:=A[i];
            A[i]:=A[j];
            A[j]:=item;
          END
      UNTIL i>=j;

      { Ted je provedeno rozlozeni           }
      { Roztrid oba zbyvajici seznamy        }
      IF (n>0) THEN
        BEGIN
          RadixExchange (A,left ,i-1  ,n-1);
          RadixExchange (A,i    ,right,n-1);
        END;
    END
END;


BEGIN {Main}

ClrScr;
Randomize;
FOR j:= 1 TO 100 DO
  BEGIN
  { Vytvorit a predobsadit seznam }
    FOR i:=1 TO N DO A[i].key:=Random(100);
    WriteLn ('Seznam',j:4,': ');
    Write (' ':10);
    FOR i:=1 TO N DO Write (A[i].key:5); WriteLn;

  { Vyvolani metody razeni:                                 }
  { -----------------------                                 }
    RadixExchange (A,1,N,KeyLen);

  { Vytvorit setrideny seznam }
    Write (' ':10);
    FOR i:=1 TO N DO Write (A[i].key:5); WriteLn;

  { Kontrola razeni }
    FOR i:=1 TO N-1 DO IF (not(A[i].key<=A[i+1].key)) THEN
      BEGIN
        WriteLn ('Error detected');
        Exit
      END;
  END;
END.

