{--------------------------------------------------------}
{ Ramcovy program metody razeni                          }
{ -------------------------------------------------------}
PROGRAM Main;

USES CRT;

CONST N = 10;                     { Velikost seznamu     }

TYPE  Tinfo  = char;              { Informace o polozce  }

      Titem  = record             { Vlastn prvek        }
                 key : integer;   { - klic               }
                 info: Tinfo;     { - informace o polozce}
               end;

      TListe = ARRAY [0..N] OF Titem;  { pole seznamu    }

VAR   A   : TListe;               { seznam na trideni    }
      i,j : integer;


{--------------------------------------------------------}
{ ShellSort - Metoda razeni Shell                        }
{--------------------------------------------------------}

PROCEDURE ShellSort (VAR A: TListe);

CONST NrIncr = 3;       { Pocet inkrementu               }

VAR                     { Pole na inkrementy             }
    hh       : ARRAY[1..NrIncr] OF integer;
    h        : integer; { aktualni inkrement             }
    i,j,k    : integer; { Ukazatel do seznamu            }
    item     : TItem;   { uchovava vkladanou    polozku  }
    StartPos : boolean; { dosazena 1. Pozice dilciho seznamu}

BEGIN
  { definovat inkrement   (Pocet=NrIncr }
  hh[1]:=5; hh[2]:=3; hh[3]:=1;

  { Jdi pres odebirane inkrementy            }
  FOR k:=1 TO NrIncr DO
    BEGIN
      h   := hh[k];     { nastav aktualni inkrement }
      FOR i:=h+1 TO N DO
        BEGIN
          { uschovat vkladany prvek }
          item :=A[i];

          { Vyhledej spravnou pozici pro vlozeni              }
          { Posun pi tom vetsi polozky dilciho seznamu       }
          { o h pozic doprava                                 }
          j        := i;
          StartPos := FALSE;
          WHILE  (Not StartPos) AND (A[j-h].key>item.key) DO
            BEGIN
              A[j]     := A[j-h];   { posunout polozku        }
              j        := j-h;      { h Pozic      --> vlevo  }
              StartPos := NOT(j>h); { dosazena prvni pozice   }
            END;

          { Vloz novy prvek           }
          A[j] := item;
        END; { FOR i}
    END; { FOR k }
END;



BEGIN {Main}

ClrScr;
Randomize;
FOR j:= 1 TO 100 DO
  BEGIN
    { Vytvorit a predobsadit seznam  }
    FOR i:=1 TO N DO A[i].key:=Random(100);
    WriteLn ('Seznam',j:4,': ');
    Write (' ':10);
    FOR i:=1 TO N DO Write (A[i].key:5); WriteLn;

    { Razeni    }
    ShellSort (A);

    { Vytvorit setrideny seznam}
    Write (' ':10);
    FOR i:=1 TO N DO Write (A[i].key:5); WriteLn;

    { Kontrola razeni   }
    FOR i:=1 TO N-1 DO IF (not(A[i].key<=A[i+1].key)) THEN
      BEGIN
        WriteLn ('Error detected');
        Exit
      END;
    ReadLn;
  END;
END.



