{ Porovnani casove slozitosti ruznych metod razeni }
{                     vypracovali                  }
{                 Robert Backhausen                }
{                   Holger Fischer                 }

PROGRAM Porovnani_casove_slozitosti;

USES CRT,DOS,Graph;

TYPE  Tinfo  = char;              { Informace o polozce     }
      Titem  = record             { Vlastni prvek        }
                 key : integer;   { - klic               }
                 info: Tinfo;     { - Informace o polozce   }
               end;

      Pixel  = record
                  x : INTEGER;
                  y : INTEGER;
                END;

      TListe = ARRAY [0..5000] OF Titem;  { Pole seznamu      }

  Pixellist = ARRAY [1..40,1..14] OF Pixel;

VAR   A,B           : TListe;               { seznam k setrideni }
      i,j,n,Step : integer;
      ElemCounter : integer;
      h1,h2,m1,m2,s1,s2,hund1,hund2 : Word;
      Bubbletime    : Longint;
      Quicktime1    : Longint;
      Quicktime2    : Longint;
      Quicktime3    : Longint;
      Quicktime4    : Longint;
      Selectiontime : Longint;
      Inserttime    : Longint;
      Shelltime     : Longint;
      Heaptime      : Longint;
      Mergetime1    : Longint;
      Mergetime2    : Longint;
      Mergetime3    : Longint;
      Radixtime     : Longint;
      Fachverttime  : Longint;
      Measure       : INTEGER;
      Measures     : INTEGER;
      SO1,SO2,SO3,SO4,SO5,SO6,SO7,SO8,SO9,SO10,SO11,SO12,SO13,SO14 : BOOLEAN;
      Input       : INTEGER;
      Graphics        : Pixellist;
      ErrorCode     : Integer;
    GrDriver, GrMode: Integer;

Function Timeindex (m1,m2,s1,s2,h1,h2 : word): LONGINT;
  VAR Time1,Time2 : LONGINT;
   BEGIN
     Time1:=((m1*60)+s1)*100+(h1);
     Time2:=((m2*60)+s2)*100+(h2);
     Timeindex:=Time2-Time1;
   END;


PROCEDURE BubbleSort (VAR A: TListe);
VAR i,j  : integer; { Ukazatel do seznamu k setrideni }
    item : TItem;   { Mezipamet k provedeni zameny   }
    XCHG : boolean; { TRUE, kdyz predchazela zamena  }
BEGIN
  i:=N;      { i=posledni Pozice  aktualniho dilciho seznamu }
  REPEAT
    { XCHG udava, zda u tohoto  dilciho seznamu      }
    { musela byt provedena zamena                    }
    XCHG := FALSE;
    { prochazet aktualni dilci seznam + pritom zamenit }
    FOR j:=1 TO i-1 DO
      IF A[j].key > A[j+1].key THEN BEGIN
                                      item   := A[j  ];
                                      A[j  ] := A[j+1];
                                      A[j+1] := item;
                                      XCHG   := TRUE;
                                    END;
    i:=i-1;
  UNTIL NOT XCHG
END;

PROCEDURE Partition (VAR A      : TListe;
                     left, right: integer;
                     VAR i      : integer );

VAR j    : integer; { Ukazatel do seznamu k setrideni }
    pivot: TItem;   { Pivot- Prvek k rozdeleni seznamu}
    item : TItem;   { Mezipamet k provedeni zameny    }

BEGIN
  { Nastavit ukazatel behu }
  i:=left-1;
  j:=right;

  { Urcit prvek PIVOT a posunout vpravo  }
  pivot                 :=A[(left+right) SHR 1];
  A[(left+right) SHR 1] :=A[right];
  A[right]              :=pivot;

  { Utvorit dilci seznam }
  REPEAT
    REPEAT  i:=i+1 UNTIL A[i].key>=pivot.key; { i bezi  }
    REPEAT  j:=j-1 UNTIL A[j].key<=pivot.key; { j bezi  }

    IF i>=j THEN
      BEGIN { i predbehlo j, umisti polozku item   }
        item    :=A[i];
        A[i]    :=A[right];
        A[right]:=item;
      END
    ELSE
      BEGIN { zamen A[i] s A[j] }
        item:=A[i];
        A[i]:=A[j];
        A[j]:=item;
      END;

  UNTIL i>=j;   { dokud se napredhoni i a j }
END;

PROCEDURE QuickSort1 (VAR A: TListe; left, right: integer);

VAR i : integer; { Ukazatel na pozici Pivot }

BEGIN
  IF (left<right) THEN { nejmene dve Polozky k dispozici }
    BEGIN
      { Rozdel seznam }
        Partition (A,left,right,i);

      { Roztrid oba zbyle seznamy }
        Quicksort1 (A,left ,i-1);
        Quicksort1 (A,i+1,right);
    END
END;


PROCEDURE QuickSort2 (VAR A: TListe; left, right: integer);
VAR i : integer; { Ukazatel  na pozici Pivot}

BEGIN
{ Iteracni prime Zpracovani vzdy vetsich            }
{ dilcich seznamu, v pripade ze jsou nejmene dve polozky }
  WHILE (left<right) DO
    BEGIN
      { Rozdel seznam   }
        Partition (A,left,right,i);

      { Zavolej rekurzivne Quicksort pro mensi dilci seznam  }
      { a hned zpracuj vetsi                                 }

      IF ((i-1)-left)<=(right-(i+1)) THEN
        BEGIN
          Quicksort2(A,left,i-1);
          left := i+1
        END
      ELSE
        BEGIN
          Quicksort2(A,i+1,right);
          right := i-1;
        END;
    END
END;


PROCEDURE QuickSort3 (VAR A: TListe; left, right: integer);

TYPE TStackItem = RECORD     { Prvek zasobniku}
                    lower: integer;
                    upper: integer;
                  END;

     Stack      = RECORD     { Zasobnik na nezpracovane polozky }
                    Top      : integer;
                    StackItem: ARRAY [1..5000] of TStackItem;
                  END;

     PStack     = ^Stack;    { Ukazatel  do zasobniku             }

VAR  S       : PStack;     { Zasobnik na nezpracovane polozky   }
     bounds  : TStackItem; { Popis polozky        [lower..upper }
     i       : Integer;    { Pivot-Pozice                     }
     pivot   : TItem;      { Prvek Pivot k rozdeleni seznamu    }
     svbound : integer;    { ulozit v mezich intervalu          }

PROCEDURE PUSH (VAR S: PStack; bounds: TStackItem);
BEGIN
  S^.Top               := S^.Top + 1;
  S^.StackItem[S^.Top] := bounds
END;


PROCEDURE POP (VAR S: PStack; VAR bounds: TStackItem);
BEGIN
  bounds := S^.StackItem[S^.Top];
  S^.Top := S^.Top - 1;
END;

Function Empty (VAR S:PStack): BOOLEAN;
BEGIN
  IF S^.Top=0 THEN Empty:=TRUE ELSE Empty:=FALSE;
END;

PROCEDURE InitStack (VAR S: PStack);
BEGIN
  New(S);
  S^.Top :=0;
END;

PROCEDURE DestroyStack (VAR S: PStack);
BEGIN
  Dispose(S)
END;

BEGIN
  { Inicializace zasobniku}
  InitStack(S);

  WITH bounds DO
    BEGIN
    { Hlavni polozku ulozit do zasobniku}
      lower := left;
      upper := right;
      Push (S,bounds);

    { Iteracni prime zpracovani vzdy vetsiho dilciho seznamu }
      WHILE NOT Empty(S) DO
        BEGIN
        { Nasledujici polozku vyjmout ze zasobniku a zpracovat ji}
          Pop(S,bounds);
          WHILE lower<upper DO
            BEGIN
              { Rozdel seznam   }
                Partition (A,lower,upper,i);

              { Vloz mensi dilci seznam do zasobniku       }
              { a hned zpracuj vetsi                       }

              IF ((i-1)-lower)<=(upper-(i+1)) THEN
                BEGIN
                 { Zapamatuj si polozku pro[lower..(i-1)] }
                   svbound := upper;
                   upper   := i-1;
                   IF lower<upper THEN Push (S,bounds);
                 { Dilci seznam [i+1..upper] ihneddal zpracovat}
                   lower:= i+1;
                   upper:= svbound;
                END
              ELSE
                BEGIN
                 { Zapamatuj si polozku pro[(i+1)..upper] }
                   svbound:=lower;
                   lower := i+1;
                   IF lower<upper THEN Push (S,bounds);
                 { Dilci seznam [lower..i-1] ihned dal zpracovat }
                   lower := svbound;
                   upper := i-1
                END
           END;
        END;
    END;
  DestroyStack(S);
END;

PROCEDURE QuickSort4 (VAR A: TListe; left,right: integer);

VAR i,j: integer;  item, pivot: TItem;

BEGIN
  IF (left<right) THEN
    BEGIN
      i:=left;
      j:=right;
      pivot := A[(left+right) DIV 2];

      REPEAT
        WHILE A[i].key<pivot.key DO i:=i+1;
        WHILE A[j].key>pivot.key DO j:=j-1;

        IF i<=j THEN BEGIN
                       item :=A[i];
                       A[i] :=A[j];
                       A[j] :=item;
                       i    :=i+1;
                       j    :=j-1;
                     END
        UNTIL i>j;

        IF left<j  THEN Quicksort4 (A,left ,j);
        IF i<right THEN Quicksort4 (A,i,right);
    END
END;

PROCEDURE SelectionSort (VAR A: TListe);

VAR i,j : integer; { Ukazatel do seznamu k setrideni  }
    min : integer; { Index monima ve zbylem poli      }
    item: Titem;   { Pomocna promenna k zamene polozek}

BEGIN
  FOR i:=1 TO N-1 DO
    BEGIN
      { nejdi minimum ve zbylem seznamu}
      min:=i;
      FOR j:=i+1 TO N DO
        IF A[j].key<A[min].key THEN min:= j;

      { zamen i-tou polozku s minimem zbyleho seznamu }
      item   := A[min];
      A[min] := A[i];
      A[i]   := item;
    END;
END;

PROCEDURE InsertionSort (VAR A: TListe);

VAR i,j,k : integer; { Ukazatel do seznamu k setrideni  }

BEGIN
  FOR i:=2 TO N DO
    BEGIN
      { ulozit prvek urceny k vlozeni                      }
      { Zaroven A[0] zastavi WHILE cyklus                  }
      A[0]:=A[i];

      { hledej spravnou pozici pro vlozeni                }
      { posun pritom vetsi polozky dilciho seznamu o jednu}
      { pozici vpravo                                     }
      j:=i;
      WHILE A[j-1].key>A[0].key DO
        BEGIN
          A[j] := A[j-1];
          j    := j-1;
        END;

      { Vloz novy prvek           }
      A[j] := A[0];

    END;
END;

PROCEDURE ShellSort (VAR A: TListe);

CONST NrIncr = 3;       { Pocet inkrementu               }

VAR                     { Pole na inkrementy             }
    hh       : ARRAY[1..NrIncr] OF integer;
    h        : integer; { aktualni inkrement             }
    i,j,k    : integer; { Ukazatel do seznamu            }
    item     : TItem;   { uchovava vkladanou    polozku  }
    StartPos : boolean; { dosazena 1. Pozice dilciho seznamu}

BEGIN
  { definovat inkrement   (Pocet=NrIncr }
  hh[1]:=5; hh[2]:=3; hh[3]:=1;

  { Jdi pres odebirane inkrementy            }
  FOR k:=1 TO NrIncr DO
    BEGIN
      h   := hh[k];     { nastav aktualni inkrement }
      FOR i:=h+1 TO N DO
        BEGIN
          { uschovat vkladany prvek }
          item :=A[i];

          { Vyhledej spravnou pozici pro vlozeni              }
          { Posun pi tom vetsi polozky dilciho seznamu       }
          { o h pozic doprava                                 }
          j        := i;
          StartPos := FALSE;
          WHILE  (Not StartPos) AND (A[j-h].key>item.key) DO
            BEGIN
              A[j]     := A[j-h];   { posunout polozku        }
              j        := j-h;      { h Pozic      --> vlevo  }
              StartPos := NOT(j>h); { dosazena prvni pozice   }
            END;

          { Vloz novy prvek           }
          A[j] := item;
        END; { FOR i}
    END; { FOR k }
END;


PROCEDURE HeapSort (VAR A: TListe; N: INTEGER);

VAR  left, right : INTEGER;    { Hranice zbyleho seznamu }
     item        : Titem;      { Pomocna promenna k zamene}


{---------------------------------------------------------------}
{ Sestup : korenovy prvek hromady se pohybuje dolu podel vetsiho}
{          uzlu stromu                                          }
{          Parametr:   A: pole s hromadou                       }
{                      r: prava mez hromady                     }
{                      l: leva mez hromady                      }
{
{---------------------------------------------------------------}
PROCEDURE Descent;

VAR i, j: INTEGER;      { Pozice Ukazatele pro sestup           }
    item : Titem;       { Pomocny prvek pro zamenu              }


BEGIN { Descent }
  i:=left;              { i ukazuje na korenovy prvek           }
  j:=2*I;               { j ukazuje na syny polozky i           }
  item:=A[I];           { zapamatovat sestupujici polozku       }

  { nech sestupovat korenovy prvek}
  WHILE j<=right DO
  BEGIN
    { Vyhledej vetsiho syna          }
    IF ( j<right ) THEN IF A[j].key < A[j+1].key THEN j:=j+1;

    IF (item.key >= A[j].key)
       { V pripade, ze sestupujici prvek je vetsi nez vsechny   }
       { pod nim, ukonci sestupovani                            }
       THEN j:=right+1  { Nastav ukoncovaci podminku pro WHILE  }

       { Jestlize jsou pod nim jeste nejake vetsi, nech posun   }
       { nizsi polozku nahoru                                   }
       ELSE BEGIN
              A[i]:=A[J];
              i := j;   { nastav i na pozici, ktera se uvolnila }
              j :=2*i;  { ukaz na prvniho syna                  }
            END
  END;

  { Sestup ukoncen: Zapis sestupujici polozku na cilovou pozici }
  A[i]:=item;
END; {Descent}

BEGIN
{ Nastav left na prvni otcovsky uzel dolnich urovni             }
  left  := (N DIV 2)+1;  { left  ---> nejspodnejsi otcovksy uzel}
  right := N;            { right ---> na pravy konec seznamu    }

{ Vystavet hromadu}
{ ----------------}
  WHILE (left>1) DO
  BEGIN
    left:=left-1;        { left ---> na dalsi koren             }
    Descent;              { nechat sestoupit aktualni koren      }
  END;

{ Razeni }
{ --------- }
  WHILE right>1 DO
  BEGIN
    { Zamenit koren hromady s poslednim prvkem zbyleho seznamu  }
    item     := A[left];
    A[left]  := A[right];
    A[right] := item;

    { Ve zbylem seznamu obnovit podminku hromady                }
    right := right-1;
    Descent;
  END;
END;

PROCEDURE Merge (VAR A: TListe; left, center, right: integer);

VAR AA : TListe;         { Pomocne pole pro roztrideny seznam}
    h, i,j,k: integer;   { Ukazatel  na smesovani               }

BEGIN
  i:=left;        { i --> dalsi prvek leve posloupnosti      }
  j:=center+1;    { j --> dalsi prvek prave posloupnosti     }
  k:=left;        { k --> prvni Pozice vysledneho seznamu  }

  WHILE (i<=center) AND (j<=right) DO
    BEGIN
      IF (A[i].key <= A[j].key) THEN BEGIN
                                       AA[k]:=A[i];
                                       i:=i+1;
                                     END
                                ELSE BEGIN
                                       AA[k]:=A[j];
                                       j:=j+1;
                                     END;
      k:=k+1;
    END;

  { kopirovat pravy resp. levy zbyly seznam do vysledneho     }
  IF i>center THEN FOR h:=j TO right  DO AA[k+h-j]:=A[h]
              ELSE FOR h:=i TO center DO AA[k+h-i]:=A[h];

  { roztrid seznam zpet do originalniho pole}
  FOR h:=left TO right DO A[h]:=AA[h]
END;


PROCEDURE MergeSort (VAR A: TListe; left, right: integer);

VAR center : integer;     { Ukazatel do stredu       }

BEGIN
  IF left<right { jen seznamy s nejmene 2 prvky!}
    THEN BEGIN
         { Rozdel na dve pulky   }
           center:=(left+right) DIV 2;

         { Roztrid obe pulky     }
           mergesort (A, left, center);
           mergesort (A,center+1,right);

         { Spoj obe pulky        }
           merge (A,left,center,right);
         END
END;

PROCEDURE StraightMergeSort (VAR A: TListe; left, right: integer);

VAR center : integer;     { Ukazatel do stredu       }
    size   : integer;     { Delka seznamu            }
    l,c,r  : integer;

BEGIN
  size :=1;    { pak smichat dilci seznamy delky 1   }

  WHILE (size<right-left+1) DO
    BEGIN        { Spojeni seznamu delky size }
      r:=left-1; { r-Ukazatel  nastavit ped celkovy seznam }

      WHILE (r+size<right) DO
        BEGIN { dokud nemame vice nez jednu castecnou posloupnost}
          l:=r+1;         { levy okraj prvn posloupnosti}
          c:=l+size-1;    { pravy okraj prvn posloupnosti}

          IF c+size<=right  THEN r:=c+size { pravy okraj }
                            ELSE r:=right; { 2.posloupnosti}

          Merge (A,l,c,r);  { Spojit!                    }
        END;

      { Vsechny castecne posloupnosti delky size spojeny }
      { dal dilci seznamy jsou dvojnasobne velke          }
        size := 2*size;
    END;
END;

PROCEDURE NaturalMergeSort (VAR A: TListe; left, right: integer);

VAR center : integer;     { Ukazatel do stredu       }
    size   : integer;     { Delka seznamu            }
    l,c,r  : integer;

BEGIN
  REPEAT
    r:=left-1;   { r-Ukazatel  inicializovat  }
    WHILE r<right DO
      BEGIN
       { levy okraj prvn posloupnosti}
         l:=r+1;

       { Zjisti maximalni uz rodtridenou castecnou posloupnost}
         c:=l;
         WHILE (c<right) AND (A[c].key <= A[c+1].key) DO c:=c+1;

       IF c<right THEN
         { Vysetrit maximalni uz roztrideny dilci seznam       }
         { a oba dva spojit                                    }
         BEGIN
           r:=c+1;
           WHILE (r<right) AND (A[r].key<=A[r+1].key) DO r:=r+1;
           Merge (A,l,c,r)
         END
       ELSE
         r:=c;  { vpravo uz nemame zadny dilci seznam      }
      END
  UNTIL l=left  { l se uz od   (**) nezmenilo, tj.       }
                { cely seznam tvori run !                 }
END;

PROCEDURE RadixExchange (VAR A      : TListe;    { Celkovy seznam}
                         left, right: integer;   { Meze         }
                         n          : integer);  { Delka klice  }

VAR i,j  : integer;                 { Ukazatele na rozdeleni    }
    item : TItem;                   { Pomocne pole na zamenu    }

FUNCTION Z(VAR b: integer; n: integer): integer;
BEGIN
  Z:=(b SHR (n-1) AND $0001);
END;

BEGIN
  IF (left<right) THEN        { k dispozici nejmene dve polozky }
    BEGIN
      i:=left -1;
      j:=right+1;

      REPEAT
        REPEAT i:=i+1
          UNTIL (Z(A[i].key,n)=1) OR (i>=j);  { i probiha}
        REPEAT j:=j-1
          UNTIL (Z(A[j].key,n)=0) OR (i>=j);  { j probiha}

        IF i<j THEN { zamen      A[i]  s  A[j] }
          BEGIN
            item:=A[i];
            A[i]:=A[j];
            A[j]:=item;
          END
      UNTIL i>=j;

      { Ted je provedeno rozlozeni           }
      { Roztrid oba zbyvajici seznamy        }
      IF (n>0) THEN
        BEGIN
          RadixExchange (A,left ,i-1  ,n-1);
          RadixExchange (A,i    ,right,n-1);
        END;
    END
END;


PROCEDURE FachVerteilen (VAR A : TListe;Keylen:INTEGER);

VAR i,j,k  : integer;          { Ukazatele na rozdeleni         }
    AA     : TListe;           { Pomocne pole pro prihradky     }
    F      : ARRAY [0..9] OF integer; { Ukazatel  na prihradky  }
    weight : integer;          { hodnost akt. pozice cifry      }


{---------------------------------------------------------------}
{ Funkce Z doda klici cifru na aktualni pozici                  }
{---------------------------------------------------------------}

FUNCTION Z(VAR b: integer): integer;
BEGIN
  Z:=(b DIV weight MOD 10);
END;


BEGIN { Prihradkove deleni}
  weight:=1; { Vaha prvniho ciferniho mista    }

  FOR i:=0 TO KeyLen-1 DO
    BEGIN { Prochazeni pozice cifry i     }

    { Urcit velikost prihradky}
      FOR j:=0 TO 9 DO F[j]:=0;
      FOR j:=1 TO N DO BEGIN
                         k    := Z(A[j].key);
                         F[k] := F[k]+1;
                       END;

    { Urcit pocatecni pozice prihradek     }
      F[9] := N+1-F[9];
      FOR j:=8 DOWNTO 0 DO F[j]:=F[j+1]-F[j];

    { Rozdeleni }
      FOR j:=1 TO N DO BEGIN
                         k        := Z(A[j].key);
                         AA[F[k]] := A[j];
                         F [k]    := F[k]+1;
      END;

    { Faze sberu  }
      FOR j:=1 TO N DO A[j]:=AA[j];

    { Pripravit hodnost dalsiho ciferniho mista }
      weight:=10*weight;

    END;
END;

PROCEDURE LINIE(xcon,ycon:REAL;i:INTEGER;Name:STRING);
VAR    xalt,xneu,yalt,yneu : INTEGER;

 BEGIN
  xalt:=640;
  xneu:=0;
  yneu:=0;
  yalt:=0;
    For Measure:=1 to Measures DO
       BEGIN
         SETCOLOR(i+1);
         xneu:=TRUNC(xcon*Graphics[Measure][i].X);
         IF xneu>=639 THEN xneu:=639;
         IF xneu<=50 THEN xneu:=50;
         yneu:=479-TRUNC(ycon*Graphics[Measure][i].Y)-51;
         If yneu>=479 THEN yneu:=479;
         LINE(xneu,yneu,xalt,yalt);
         xalt:=xneu;
         yalt:=yneu;
       END;
       OUTTEXTXY(60,5+(i*10),Name);
    END;

PROCEDURE GRAPHICS_OUTPUT;
VAR MAXWERT_X,MAXWERT_Y:LONGINT;
    xcon,ycon : REAL;
    xscale,yscale : STRING;
begin
  MAXWERT_X:=0;
  MAXWERT_Y:=0;
  FOR i:=1 to 14 DO
    For Measure:=1 to Measures DO
      BEGIN
       IF Graphics[Measure][i].X>MAXWERT_X THEN
          MAXWERT_X:=Graphics[Measure][i].X;
       IF Graphics[Measure][i].Y>MAXWERT_Y THEN
          MAXWERT_Y:=Graphics[Measure][i].Y;
      END;

  xcon:=590/MAXWERT_X;
  ycon:=430/MAXWERT_Y;

  GrDriver := Detect;
  InitGraph(GrDriver, GrMode, '');
  ErrorCode := GraphResult;   { Check for errors }
  if ErrorCode <> grOk then
  begin
    Writeln('Graphics error:');
    Writeln(GraphErrorMsg(ErrorCode));
    Writeln('Program aborted...');
    Halt(1);
  end;
  ClearDevice;   { Do some graphics... }
  Rectangle(50, 0, GetMaxX, GetMaxY-50);
  SETTEXTSTYLE(1,1,1);
  OUTTEXTXY(8,100,'Potrebuji cas v  milisekundach ');
  SETTEXTSTYLE(1,0,1);
  OUTTEXTXY(250,465,'Pocet prvku   ');

  for i:=1 to 10 DO
    BEGIN
      STR(TRUNC(i*MAXWERT_X/10),XSCALE);
      STR(TRUNC(i*MAXWERT_Y/10),YSCALE);
      OUTTEXTXY(i*64,440,XSCALE);
      OUTTEXTXY(17,480-(i*48),YSCALE);
    END;

  For i:=1 to 14 DO
  IF (i=1) AND SO1 THEN Linie(xcon,ycon,i,'Bubblesort')
  ELSE
  IF (i=2) AND SO2 THEN Linie(xcon,ycon,i,'Quicksort rekurzivni')
  ELSE
  IF (i=3) AND SO3 THEN Linie(xcon,ycon,i,'Quicksort O(LOG(N) pam. slozitost -rekurzivne')
  ELSE
  IF (i=4) AND SO4 THEN Linie(xcon,ycon,i,'Quicksort O(LOG(N) pam. slozitost - nerekurzivne')
  ELSE
  IF (i=5) AND SO5 THEN Linie(xcon,ycon,i,'Quicksort podle Wirtha')
  ELSE
  IF (i=6) AND SO6 THEN Linie(xcon,ycon,i,'Select Sort')
  ELSE
  IF (i=7) AND SO7 THEN Linie(xcon,ycon,i,'Insert Sort')
  ELSE
  IF (i=8) AND SO8 THEN Linie(xcon,ycon,i,'Shell Sort')
  ELSE
  IF (i=9) AND SO9 THEN Linie(xcon,ycon,i,'Heap Sort')
  ELSE
  IF (i=10) AND SO10 THEN Linie(xcon,ycon,i,'Merge Sort')
  ELSE
  IF (i=11) AND SO11 THEN Linie(xcon,ycon,i,'StraightMerge Sort')
  ELSE
  IF (i=12) AND SO12 THEN Linie(xcon,ycon,i,'NaturalMerge Sort')
  ELSE
  IF (i=13) AND SO13 THEN Linie(xcon,ycon,i,'Radix Exchange')
  ELSE
  IF (i=14) AND SO14 THEN Linie(xcon,ycon,i,'Prihradkove deleni');
  READLN;
  CloseGraph;
end;




BEGIN {Main}
ClrScr;
WRITELN('Porovnani metod razeni!');
WRITELN('');
WRITELN('Vyberte si asi 4 Metody pro srovnani.');
WRITELN('K tomu zadejte cislo a [ENTER].');
WRITELN('Az budete hotovi s vyberem, stisknete 0 a [ENTER]');
WRITELN('');
WRITELN(' 1.Bubblesort:...............................................');
WriteLN(' 2.Quicksort (Rekurzivni)....................................');
WriteLN(' 3.Quicksort (O(Log(N) Pam. slozitost - rekuzivni)...........');
WriteLN(' 4.Quicksort (O(Log(N) Pam. slozitost - nerekurzivni)........');
WriteLN(' 5.Quicksort (rekurzivne podle Wirtha).......................');
WriteLN(' 6.Select Sort...............................................');
WriteLN(' 7.Insert Sort.......................................................');
WriteLN(' 8.Shell Sort................................................');
WriteLN(' 9.Heap Sort.................................................');
WriteLN('10.Merge Sort................................................');
WriteLN('11.StraightMerge Sort........................................');
WriteLN('12.NaturalMerge Sort.........................................');
WriteLN('13.RadixExchange.............................................');
WriteLN('14.Prihradkove deleni........................................');
WRITELN('');
SO1:=FALSE;SO2:=SO1;SO3:=SO1;SO4:=SO1;SO5:=SO1;SO6:=SO1;SO7:=SO1;SO8:=SO1;
SO9:=SO1;SO10:=SO1;SO11:=SO1;SO12:=SO1;SO13:=SO1;SO14:=SO1;
REPEAT
READ(INPUT);
IF Input=1 THEN SO1:=TRUE;
IF INPUT=2 THEN SO2:=TRUE;
IF Input=3 THEN SO3:=TRUE;
IF INPUT=4 THEN SO4:=TRUE;
IF Input=5 THEN SO5:=TRUE;
IF INPUT=6 THEN SO6:=TRUE;
IF Input=7 THEN SO7:=TRUE;
IF INPUT=8 THEN SO8:=TRUE;
IF Input=9 THEN SO9:=TRUE;
IF INPUT=10 THEN SO10:=TRUE;
IF Input=11 THEN SO11:=TRUE;
IF INPUT=12 THEN SO12:=TRUE;
IF Input=13 THEN SO13:=TRUE;
IF INPUT=14 THEN SO14:=TRUE;
UNTIL Input=0;
Write('Zadejte poet prvku:');
Readln(ElemCounter);
Write('Zadejte poet mereni:');
Readln(Measures);
Randomize;

FOR i:=1 TO ElemCounter DO A[i].key:=Random(ElemCounter);
 B:=A;  {Ulozit testovaci seznam pro dal metody razeni}

Step:=ElemCounter DIV Measures;
N:=ElemCounter+Step;
For Measure:=1 to Measures DO
  BEGIN
    N:=N-Step;
    WRITELN('');
    WRITELN('');
    WRITELN('Casy razeni pro ',N,' prvku!');
    WRITELN('');
    { Predobsadit a vypsat seznam    }

IF SO1 THEN
   BEGIN
    A:=B; {Pro novou metodu razeni vratit seznam do puvodniho stavu}
    WRITE(' 1.Bubblesort:...............................................');
    GetTime(h1,m1,s1,hund1);
    BubbleSort (A);
    GetTime(h2,m2,s2,hund2);
    Bubbletime:=TimeIndex(m1,m2,s1,s2,hund1,hund2);
    WriteLn(Bubbletime:8);
    Graphics[measure][1].X:=N;
    GRAPHICS[measure][1].y:=Bubbletime;
   END;

IF SO2 THEN
   BEGIN
    A:=B; {Pro novou metodu razeni vratit seznam do puvodniho stavua}
    Write(' 2.Quicksort (rekurzivne)......................................');
    GetTime(h1,m1,s1,hund1);
    Quicksort1 (A,1,N);
    GetTime(h2,m2,s2,hund2);
    Quicktime1:=TImeIndex(m1,m2,s1,s2,hund1,hund2);
    WriteLn(Quicktime1:8);
    Graphics[measure][2].X:=N;
    GRAPHICS[measure][2].y:=Quicktime1;
  end;

IF SO3 THEN
   BEGIN
    A:=B; {Pro novou metodu razeni vratit seznam do puvodniho stavu}
    Write(' 3.Quicksort (O(Log(N) Zusatzspeicher - rekurzivne...........');
    GetTime(h1,m1,s1,hund1);
    Quicksort2 (A,1,N);
    GetTime(h2,m2,s2,hund2);
    Quicktime2:=TImeIndex(m1,m2,s1,s2,hund1,hund2);
    WriteLn(Quicktime2:8);
    Graphics[measure][3].X:=N;
    GRAPHICS[measure][3].y:=Quicktime2;
  end;

IF SO4 THEN
   BEGIN
    A:=B; {Pro novou metodu razeni vratit seznam do puvodniho stavu}
    Write(' 4.Quicksort (O(Log(N) Zusatzspeicher - nerekurzivne.........');
    GetTime(h1,m1,s1,hund1);
    Quicksort3 (A,1,N);
    GetTime(h2,m2,s2,hund2);
    Quicktime3:=TImeIndex(m1,m2,s1,s2,hund1,hund2);
    WriteLn(Quicktime3:8);
    Graphics[measure][4].X:=N;
    GRAPHICS[measure][4].y:=Quicktime3;
  end;

IF SO5 THEN
   BEGIN
    A:=B; {Pro novou metodu razeni vratit seznam do puvodniho stavu}
    Write(' 5.Quicksort (rekurzivne podle Wirtha).........................');
    GetTime(h1,m1,s1,hund1);
    Quicksort4 (A,1,N);
    GetTime(h2,m2,s2,hund2);
    Quicktime4:=TImeIndex(m1,m2,s1,s2,hund1,hund2);
    WriteLn(Quicktime4:8);
    Graphics[measure][5].X:=N;
    GRAPHICS[measure][5].y:=Quicktime4;
   end;

IF SO6 THEN
   BEGIN
    A:=B; {Pro novou metodu razeni vratit seznam do puvodniho stavu}
    Write(' 6.Selection Sort............................................');
    GetTime(h1,m1,s1,hund1);
    SelectionSort (A);
    GetTime(h2,m2,s2,hund2);
    Selectiontime:=TImeIndex(m1,m2,s1,s2,hund1,hund2);
    WriteLn(Selectiontime:8);
    Graphics[measure][6].X:=N;
    GRAPHICS[measure][6].y:=Selectiontime;
  end;

IF SO7 THEN
   BEGIN
    A:=B; {Pro novou metodu razeni vratit seznam do puvodniho stavua}
    Write(' 7.Insertion Sort............................................');
    GetTime(h1,m1,s1,hund1);
    InsertionSort (A);
    GetTime(h2,m2,s2,hund2);
    Inserttime:=TImeIndex(m1,m2,s1,s2,hund1,hund2);
    WriteLn(Inserttime:8);
    Graphics[measure][7].X:=N;
    GRAPHICS[measure][7].y:=Inserttime;
   end;

IF SO8 THEN
   BEGIN
    A:=B; {Pro novou metodu razeni vratit seznam do puvodniho stavu}
    Write(' 8.Shell Sort................................................');
    GetTime(h1,m1,s1,hund1);
    ShellSort (A);
    GetTime(h2,m2,s2,hund2);
    Shelltime:=TImeIndex(m1,m2,s1,s2,hund1,hund2);
    WriteLn(Shelltime:8);
    Graphics[measure][8].X:=N;
    GRAPHICS[measure][8].y:=Shelltime;
   end;

IF SO9 THEN
   BEGIN
    A:=B; {Pro novou metodu razeni vratit seznam do puvodniho stavu}
    Write(' 9.Heap Sort.................................................');
    GetTime(h1,m1,s1,hund1);
    HeapSort (A,N);
    GetTime(h2,m2,s2,hund2);
    Heaptime:=TImeIndex(m1,m2,s1,s2,hund1,hund2);
    WriteLn(Heaptime:8);
    Graphics[measure][9].X:=N;
    GRAPHICS[measure][9].y:=Heaptime;
  end;

IF SO10 THEN
   BEGIN
    A:=B; {Pro novou metodu razeni vratit seznam do puvodniho stavu}
    Write('10.Merge Sort................................................');
    GetTime(h1,m1,s1,hund1);
    Mergesort (A,1,N);
    GetTime(h2,m2,s2,hund2);
    Mergetime1:=TImeIndex(m1,m2,s1,s2,hund1,hund2);
    WriteLn(Mergetime1:8);
    Graphics[measure][10].X:=N;
    GRAPHICS[measure][10].y:=Mergetime1;
  end;

IF SO11 THEN
   BEGIN
    A:=B; {Pro novou metodu razeni vratit seznam do puvodniho stavu}
    Write('11.StraightMerge Sort........................................');
    GetTime(h1,m1,s1,hund1);
    StraightMergesort (A,1,N);
    GetTime(h2,m2,s2,hund2);
    Mergetime2:=TImeIndex(m1,m2,s1,s2,hund1,hund2);
    WriteLn(Mergetime2:8);
    Graphics[measure][11].X:=N;
    GRAPHICS[measure][11].y:=Mergetime2;
   end;

IF SO12 THEN
   BEGIN
    A:=B; {Pro novou metodu razeni vratit seznam do puvodniho stavu}
    Write('12.NaturalMerge Sort.........................................');
    GetTime(h1,m1,s1,hund1);
    NaturalMergesort (A,1,N);
    GetTime(h2,m2,s2,hund2);
    Mergetime3:=TImeIndex(m1,m2,s1,s2,hund1,hund2);
    WriteLn(Mergetime3:8);
    Graphics[measure][12].X:=N;
    GRAPHICS[measure][12].y:=Mergetime3;
   end;

IF SO13 THEN
   BEGIN
    A:=B; {Pro novou metodu razeni vratit seznam do puvodniho stavu}
    Write('13.RadixExchange.............................................');
    GetTime(h1,m1,s1,hund1);
    RadixExchange (A,1,N,16);
    GetTime(h2,m2,s2,hund2);
    Radixtime:=TImeIndex(m1,m2,s1,s2,hund1,hund2);
    WriteLn(Radixtime:8);
    Graphics[measure][13].X:=N;
    GRAPHICS[measure][13].y:=Radixtime;
   end;

IF SO14 THEN
   BEGIN
    A:=B; {Pro novou metodu razeni vratit seznam do puvodniho stavu}
    Write('14.Prihradkove deleni........................................');
    GetTime(h1,m1,s1,hund1);
    Fachverteilen (A,4);
    GetTime(h2,m2,s2,hund2);
    Fachverttime:=TImeIndex(m1,m2,s1,s2,hund1,hund2);
    WriteLn(Fachverttime:8);
    Graphics[measure][14].X:=N;
    GRAPHICS[measure][14].y:=Fachverttime;
  END;
 END;

 GRAPHICS_OUTPUT;

END.
